/* =========================================================================

NAME: UltraBorder

AUTHOR: Oleg Butrin (obutrin@indesign.rudtp.ru)
HOMEPAGE: http://indesign.rudtp.ru
DATE  : 26.11.2004 15:56



COMMENT:
Script make border around paragraph with custom paragraph style applied

RIGHT:
You have the right to use and distribute this script.
You have the right to modify this script for own needs. 
It is desirable to send the variant to the author of a script.
You have no right to distribute the modified script from author's name.
You have no right to have profit from sale of a script.

The author of a script does not sustain the responsibility in all cases of loss data and other kinds of losses if they have arisen in the time of using a script.
You use this script at your own fear and risk.

============================================================================ */
//
// 
function tablePreset(myTable) {
//  ,    
	if (myTable != null) {
		var myCell = myTable.cells[0];
		with (myCell) {
			this.strokeColor = new Array(topEdgeStrokeColor.name, bottomEdgeStrokeColor.name, leftEdgeStrokeColor.name, rightEdgeStrokeColor.name);
			this.strokeTint = new Array(topEdgeStrokeTint, bottomEdgeStrokeTint, leftEdgeStrokeTint, rightEdgeStrokeTint);
			this.strokeType = new Array(topEdgeStrokeType.name, bottomEdgeStrokeType.name, leftEdgeStrokeType.name, rightEdgeStrokeType.name);
			this.strokeWeight = new Array(topEdgeStrokeWeight, bottomEdgeStrokeWeight, leftEdgeStrokeWeight, rightEdgeStrokeWeight);
			this.inset = new Array(topInset, bottomInset, leftInset, rightInset);
			this.color = fillColor.name;
			this.tint = fillTint;
			this.height = height; // ***    ***
		}
		var myObject = myTable;
		while (myObject.constructor.name != "Document") {
			var myObject = myObject.parent;
		}
		this.vertMeasurement = myObject.viewPreferences.verticalMeasurementUnits;
		this.horizMeasurement = myObject.viewPreferences.horizontalMeasurementUnits;
//   -   		
	} else {
		this.strokeColor = "";
		this.strokeTint = "";
		this.strokeType = "";
		this.strokeWeight = "";
		this.inset = "";
		this.color = "";
		this.tint = "";
		this.vertMeasurement = "";
		this.horizMeasurement = "";
		this.height = ""; // ***    ***
	}
}
//   
function applyPreset (myParagraph, mySpaceBefore, mySpaceAfter) {
//    
	if (myParagraph == null) {
		return null;
	}
//   
	var myObject = myParagraph.parentStory;
	while (myObject.constructor.name != "Document") {
		var myObject = myObject.parent;
	}
//     	
	var myVM = myObject.viewPreferences.verticalMeasurementUnits;
	var myHM = myObject.viewPreferences.horizontalMeasurementUnits;
	myObject.viewPreferences.verticalMeasurementUnits = myPreset.vertMeasurement;
	myObject.viewPreferences.horizontalMeasurementUnits = myPreset.horizMeasurement;
//      
	var myTable = myParagraph.tables.add(LocationOptions.atBeginning, undefined,
		{
			columnCount:1,
			bodyRowCount:1,
			headerRowCount:0,
			footerRowCount:0,
			topBorderStrokeColor:myObject.colors.item(String(this.strokeColor[0])),
			bottomBorderStrokeColor:myObject.colors.item(String(this.strokeColor[1])),
			leftBorderStrokeColor:myObject.colors.item(String(this.strokeColor[2])),
			rightBorderStrokeColor:myObject.colors.item(String(this.strokeColor[3])),
			topBorderStrokeTint:Number(this.strokeTint[0]),
			bottomBorderStrokeTint:Number(this.strokeTint[1]),
			leftBorderStrokeTint:Number(this.strokeTint[2]),
			rightBorderStrokeTint:Number(this.strokeTint[3]),
			topBorderStrokeType:myObject.strokeStyles.item(String(this.strokeType[0])),
			bottomBorderStrokeType:myObject.strokeStyles.item(String(this.strokeType[1])),
			leftBorderStrokeType:myObject.strokeStyles.item(String(this.strokeType[2])),
			rightBorderStrokeType:myObject.strokeStyles.item(String(this.strokeType[3])),
			topBorderStrokeWeight:Number(this.strokeWeight[0]),
			bottomBorderStrokeWeight:Number(this.strokeWeight[1]),
			leftBorderStrokeWeight:Number(this.strokeWeight[2]),
			rightBorderStrokeWeight:Number(this.strokeWeight[3])
		}
	);
// 
	var myCell = myTable.cells[0];
	with (myCell) {
		topInset = Number(this.inset[0]);
		bottomInset = Number(this.inset[1]);
		leftInset = Number(this.inset[2]);
		rightInset = Number(this.inset[3]);
		fillColor = myObject.colors.item(this.color);
		fillTint = Number(this.tint);
		height = this.height; // ***   ***
	}
//  
	var myText = myParagraph.characters.itemByRange(1, (myParagraph.characters.length - 2));
// -  
	myObject.viewPreferences.verticalMeasurementUnits = myVM;
	myObject.viewPreferences.horizontalMeasurementUnits = myHM;	
//   (     ,  )
	myTable.spaceBefore = mySpaceBefore;
	myTable.spaceAfter = mySpaceAfter;
// 
	myText.select(SelectionOptions.replace);
// 
	app.cut();
// 
	myCell.insertionPoints[0].select(SelectionOptions.replace);
// 
	app.paste();
}
tablePreset.prototype.applyPreset = applyPreset;

//  
function checkPreset(myDoc) {
	var myResult = true;
// , 
	for (myCounter = 0; myCounter < this.strokeColor.length; myCounter++) {
		try {
			var myCheck = myDoc.colors.item(this.strokeColor[myCounter]);
			var myCheckName = myCheck.name;
		} catch (error) {
			myResult = false;
		}
	}
	for (myCounter = 0; myCounter < this.strokeType.length; myCounter++) {
		try {
			var myCheck = myDoc.strokeStyles.item(this.strokeType[myCounter]);
			var myCheckName = myCheck.name;
		} catch (error) {
			myResult = false;
		}
	}
	try {
		var myCheck = myDoc.colors.item(this.color);
		var myCheckName = myCheck.name;
	} catch (error) {
		myResult = false;
	}
	return myResult;
}
tablePreset.prototype.checkPreset = checkPreset;

//  
function writeFile(myFile) {
	var myResult = myFile.open("w");
	if (!myResult) {
		alert(langNotOpenWrite);
		exit();
	}
	var myString = "";
	for (var field in this) {
		if (typeof(this[field]) != "function") {
			myString += field + "%|%" + typeof(this[field]) + "%|%" + this[field] + "\n";
		}
	}
	myFile.write(myString);
	myFile.close();
}
tablePreset.prototype.writeFile = writeFile;

//  
function readFile(myFile) {
	var myResult = myFile.open("r");
	if (!myResult) {
		alert(langNotOpenRead);
		exit();
	}
	var myArray = new Array();
	var myCounter = 0
	while (!myFile.eof) {
		myArray[myCounter] = myFile.readln().split("%|%");
		myCounter++;
	}
	myFile.close();
// 
	for (myCounter = 0; myCounter < myArray.length; myCounter++) {
		switch (myArray[myCounter][1]) {
			case "number":
				this[String(myArray[myCounter][0])] = Number(myArray[myCounter][2]);
			break;
			case "string":
				this[String(myArray[myCounter][0])] = String(myArray[myCounter][2]);
			break;
			case "object":
				this[String(myArray[myCounter][0])] = (myArray[myCounter][2]).split(",");
			break;
		}
	}
}
tablePreset.prototype.readFile = readFile;

//   
function fileNameCheck (myFile, myExt) {
	var myPath = app.activeScript.path;
	var myName = myFile.name;
	if (myName.substring((myName.length - myExt.length), ) != myExt) {
		myName +=myExt;
	}
	return new File (myPath + "/" + myName);
}

//   
function getNameOfFiles(myArray) {
	var myResult = new Array();
	for (myCounter = 0; myCounter < myArray.length; myCounter++) {
		var myFile = new File (myArray[myCounter]);
		myResult[myCounter] = myFile.name;
	}
	return myResult;
}

// 
with (app) {
// ini-   
	var myIniFile = new File (activeScript.path + "/megaBorder.ini");
	if (!myIniFile.exists) {
		alert("Can\'t find ini file!");
		exit ();
	} else {
		eval ("//@include \'megaBorder.ini\';");
	}
	var myLangFile = new File (activeScript.path + "/" + iniLangFile);
	if (!myLangFile.exists) {
		alert("Can\'t find lang file!");
		exit ();
	} else {
		eval ("//@include \'" + iniLangFile + "\';");
	}
// 	
	if (documents.length < 1) {
		alert(langNoDoc);
		exit();
	}
// 	
	if (selection.length != 1) {
		alert(langNoSelection);
		exit();
	}
	var myDoc = activeDocument;
//   
	if ((selection[0].parent.constructor.name == "Cell") || (selection[0].parent.constructor.name == "Table")) {
//  
		var myResult = confirm(langTableSelected);
		if (myResult) {
			var myObject = selection[0];
			while (myObject.constructor.name != "Table") {
				var myObject = myObject.parent;
			}
// 
			var myPreset = new tablePreset(myObject);
			Folder.current = activeScript.path;
//
			var myFile = File.saveDialog(iniScriptName + " " + iniScriptVersion + ". " + langSavePreset, iniFileType);
			if (!myFile) {
				alert(langNoSelectFile);
				exit();
			}
			myFile = fileNameCheck(myFile, ".borderpres");
			myPreset.writeFile(myFile);
			alert(langPresetSaved);
			exit();
		}
	}
// 
	switch (selection[0].constructor.name) {
		case "InsertionPoint":
			var myStory = selection[0].parentStory;
			break;
		case "Text":
			var myStory = selection[0].parentStory;
			break;
		case "TextFrame":
			var myStory = selection[0].parentStory;
			break;
		case "Cell":
			var myStory = selection[0].parent.parent.parentStory;
			break;
		default:
			alert(langNoSelection);
			exit();
	}
//  	
	var myStyleNames = new Array();
	for (myCounter = 0; myCounter < myDoc.paragraphStyles.length; myCounter++) {
		myStyleNames[myCounter] = myDoc.paragraphStyles[myCounter].name;
	}
//  	
	var myFolder = new Folder(activeScript.path);
	var myPresetFiles = myFolder.getFiles("*.borderpres");
	if (myPresetFiles.length < 1) {
		alert(langNoPresets);
		exit();
	}
//   	
	var myPresetNames = getNameOfFiles(myPresetFiles);
	var myDialog = dialogs.add({name:iniScriptName + " " + iniScriptVersion});
//
	with (myDialog.dialogColumns.add()) {
		with (dialogRows.add().borderPanels.add().dialogColumns.add()) {
			dialogRows.add().staticTexts.add({staticLabel:langSelectStyle});
			var mySelectStyle = dialogRows.add().dropdowns.add({stringList:myStyleNames, selectedIndex:0});
			var myRemoveBorders = dialogRows.add().checkboxControls.add({staticLabel:langRemoveBorders, checkedState:false});
			dialogRows.add().staticTexts.add({staticLabel:langSelectPreset});
			var mySelectPreset = dialogRows.add().dropdowns.add({stringList:myPresetNames, selectedIndex:0});
			with (dialogRows.add()) {
				with (dialogColumns.add()) {
					dialogRows.add().staticTexts.add({staticLabel:langSpaceBefore});
					dialogRows.add().staticTexts.add({staticLabel:langSpaceAfter});
				}
				with (dialogColumns.add()) {
					var mySelectSpaceBefore = dialogRows.add().measurementEditboxes.add({editUnits:myDoc.viewPreferences.horizontalMeasurementUnits, minimumValue:0, maximumValue:72, largeNudge:0.1, smallNudge:0.1, editContents:iniSpaceBefore});
					var mySelectSpaceAfter = dialogRows.add().measurementEditboxes.add({editUnits:myDoc.viewPreferences.horizontalMeasurementUnits, minimumValue:0, maximumValue:72, largeNudge:0.1, smallNudge:0.1, editContents:iniSpaceAfter});
				}
			}
		}
		with (dialogRows.add().dialogColumns.add()) {
			dialogRows.add().staticTexts.add({staticLabel:"\u00A9 Oleg Butrin"});
			dialogRows.add().staticTexts.add({staticLabel:"http://indesign.rudtp.ru"});
		}

	}
// 	
	var myResult = myDialog.show();
	if (!myResult) {
		myDialog.destroy();
		exit();
	}
	var myStyle = myDoc.paragraphStyles[mySelectStyle.selectedIndex];
//    
	if (myRemoveBorders.checkedState) {
		var myTables = new Array();
		for (myCounter = 0; myCounter < myStory.tables.length; myCounter++) {
			myTables[myCounter] = myStory.tables[myCounter]
		}
		
		myTables.reverse();
		for (myCounter = 0; myCounter < myTables.length; myCounter++) {
			var myTable = myTables[myCounter];
			if (myTable.cells[0].paragraphs[0].appliedParagraphStyle == myStyle) {
				myTable.convertToText();
			}
		}
		if (iniSaveDocumentOnEnd) {
			myDoc.save(myDoc.fullName);
		}
		myDialog.destroy();
		exit();
	}
//   
	var myPreset = new tablePreset();
	myPreset.readFile(myPresetFiles[mySelectPreset.selectedIndex]);
	if (!myPreset.checkPreset(myDoc)) {
		alert(langWrongPreset);
		myDialog.destroy();
		exit();
	}
//  	
	var myInteration = 0;
//   
	for (myCounter = 0; myCounter < myStory.paragraphs.length; myCounter++) {
		if ((myStory.paragraphs[myCounter].parent.constructor.name != "Cell") && (myStory.paragraphs[myCounter].appliedParagraphStyle == myStyle)) {
//
			var myTable = myPreset.applyPreset(myStory.paragraphs[myCounter], mySelectSpaceBefore.editContents, mySelectSpaceAfter.editContents);
			myInteration++;
			if ((myInteration > iniInteration) && iniSaveDocumentOnInteration) {
				myDoc.save(myDoc.fullName);
			}
		}
	}
	if (iniSaveDocumentOnEnd) {
		myDoc.save(myDoc.fullName);
	}
	myDialog.destroy();
	exit();
}